;in 4gw leave es, ds alone
;bp, sp =>ebp, esp
;[ebp+8], [ebp+12]
;ax dx bx cx
stackseg        segment stack 'stack'
        db      512 dup (?)
stackseg        ends

public  init_           ;initialize screen 13
public  mode80_         ;go back to text mode
public  pset_           ;put a pixel on the screen
public  keypress_       ;return nozero if a key has been pressed
public  palette_        ;set the palette
public  put_            ;block copy a pic to the screen
public  putran_         ;put a picture with transparent on screen
public  putcan_         ;put a pic. with transparent on canvas
public  clearcan_       ;clear the canvas
public  paint_          ;fill the screen with a color
public  paintcan_       ;fill the screen with the canvas
before  macro
        push ebp      ;Save the base pointer
        mov ebp,esp          ;Copy the stack pointer
        push    esi
        push    edi
        endm

; Postfix -- Returns the pointers to the condition they were in when
;               the C program called the routine

after   macro
        pop     edi
        pop     esi
        mov     esp, ebp   ;Restore the stack pointer
        pop     ebp
             ;Restore the base pointer
        ret             ;return from subroutine
        endm

_cdseg  segment byte public 'CODE'      ;Program segment begins here

;set 320*200*256 mode
;no arguements
init_   proc near
        mov ax, 13h
        int 10h
        ret
init_   endp
;---------
;set text mode
;no arguements
mode80_ proc near
        mov ax, 03h
        int 10h
        ret
mode80_ endp
;---------
;put a pixel on the screen
; eax = x
; edx = y
; ebx = color
pset_   proc near
        before
     
        mov edi, 0a0000h  ;vga mem
        add edi, eax
        mov eax, edx
        mov ecx, 320
        mul ecx     
        add edi, eax
        mov [edi], bl

        after
        ret
pset_   endp

;---------
;---------
;paint the whole screen 
; eax = color  (actually al)
paint_  proc near
        before
     
        mov edi, 0a0000h  ;vga mem
        mov ecx, 32000
        mov ah, al      
        mov bx, ax      ;save the color
        mov edx, 10000h
        mul edx
        mov ax, bx
        rep stosw

        after
        ret
paint_  endp

;---------
;---------
;paint the whole screen with the canvas
; eax = canvas
paintcan_  proc near
        before
        mov esi, eax
        mov edi, 0a0000h  ;vga mem
        mov ecx, 16000
        ;no flicker wait for screen retrace
vertic:
        mov dx, 03dah
        in al, dx
        test al, 8
        jz vertic
        rep movsd
        after
        ret
paintcan_  endp

;---------
;---------
;clear the canvas
; eax = canvas
clearcan_  proc near
        before
        mov edi, eax
        mov ecx, 16000
        mov eax, 0
        rep stosd
        after
        ret
clearcan_  endp

;---------
;ebx picture
;eax x coordinate
;edx y coordinate
put_    proc near
        before
        mov esi, ebx
        mov edi, 0a0000h
        add edi, eax        
        mov eax, edx
        mov ecx, 320
        mul ecx
        add edi, eax

        mov eax, 0  
        ;add si, 4
        lodsw
        mov ebx, eax
        lodsw
        mov ecx, eax
        inc ecx
        inc ebx


        mov edx, 320
        sub edx, ebx

hmmm:
        push ecx
        mov ecx, ebx
        shr ecx, 1
        jnc odd
        movsb
odd:
        rep movsw
        ;rep movsb

        pop ecx
        add edi, edx
        dec ecx
        jnz hmmm

        after
put_    endp

;---------
;---------
;ebx picture
;eax x coordinate
;edx y coordinate
putran_ proc near
        before
        mov esi, ebx
        mov edi, 0a0000h
        add edi, eax        
        mov eax, edx
        mov ecx, 320
        mul ecx
        add edi, eax

        mov eax, 0  
        ;add si, 4
        lodsw
        mov ebx, eax
        lodsw
        mov ecx, eax
        inc ecx
        inc ebx


        mov edx, 320
        sub edx, ebx

him:
        push ecx
        mov ecx, ebx
prob:
        lodsb
        cmp al, 255     ;see if transparrent
        je clear
        mov [edi], al
clear:
        inc edi
        dec ecx
        jnz prob        
        ;rep movsb

        pop ecx
        add edi, edx
        dec ecx
        jnz him

        after
putran_ endp

;---------
;---------
;ebx picture
;eax x coordinate
;edx y coordinate
;ecx canvas
putcan_ proc near
        before
        mov esi, ebx
        mov edi, ecx
        add edi, eax        
        mov eax, edx
        mov ecx, 320
        mul ecx
        add edi, eax

        mov eax, 0  
        ;add si, 4
        lodsw
        mov ebx, eax
        lodsw
        mov ecx, eax
        inc ecx
        inc ebx


        mov edx, 320
        sub edx, ebx

his:
        push ecx
        mov ecx, ebx
problem:
        lodsb
        cmp al, 255     ;see if transparrent
        je clearer
        mov [edi], al
clearer:
        inc edi
        dec ecx
        jnz problem        
        ;rep movsb

        pop ecx
        add edi, edx
        dec ecx
        jnz his

        after
putcan_ endp

;---------
;returns nonzero for keypressed
keypress_ proc near
        before
        mov eax, 0
        mov ah, 0bh
        int 21h
        mov ah, 0
        after
keypress_ endp    
;---------
;eax pallete

palette_  proc near
        ;lets move some color
        before
        mov esi, eax           ;offset of pallette
        mov cx, 256
well:
        mov dx, 3c8h
        mov ax, 256
        sub ax, cx
        out dx, al
        mov dx, 3c9h
        lodsb
        out dx, al
        lodsb
        out dx, al
        lodsb
        out dx, al
        dec cx
        jnz well
        after
        ret
palette_        endp
;--------------
_cdseg          ends                   ;End code segment
        end                    ;End program
