#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include <dos.h>                //for delay
#include <time.h>                //for delay
#define NUMBER 7

/*********************************************/
void init(void);
void mode80(void);
char keypress(void);
void paint(int color);
void paintcan(unsigned char *canvas);
void clearcan(unsigned char *canvas);
void pset(int x, int y, int color);
void put(int x, int y, unsigned char *picture);
void putran(int x, int y, unsigned char *picture);
void putcan(int x, int y, unsigned char *picture, unsigned char *canvas);
void palette(unsigned char *pal);
/*********************************************/
//the vector structure i, j, k
typedef struct vectors {           
  float i, j, k;
  } vector, *vectorptr;

//a set of 3 unit vectors used to determine an axis, ie for DOF or x, y, z
typedef struct axi {
  vector x, y, z;
  } axis, *axisptr;

//the linked list structure of coordinates in an object
typedef struct coordinates  {           
  int x, y, z;
  struct coordinates *next;
  } pair, *pairptr;

/*********************************************/
//create and return an empty list
pairptr create_empty(){
pairptr empty;
empty=NULL;
return empty;
}
 
/*********************************************/

/*read in a file to a pointer given size and filename*/
unsigned char *
diskread(char *strn, int size)  {
  FILE *myfile;
  unsigned char *dater;

  if ((dater=malloc(size))==NULL)  {
    printf("DAMNIT");
  }
  if ((myfile = fopen(strn, "rb"))==NULL)  {
    printf("DAMN");
  }
  fread(dater, size, 1, myfile);
  fclose(myfile);
  return dater;
}

/***********************************************/
pairptr destroy_full_list(pairptr list)  {
/*frees the memory from a list that is no longer needed*/
pairptr temp;
while (list!=NULL)  {
  temp=list;                    /*don't lose pointer*/
  list=list->next;     /*go to next*/
  free(temp);                   /*erase it*/
  }
return NULL;                    /*return NULL to the pointer cleared*/
}
/***********************************************/
pairptr insert(pairptr top, int x, int y, int z)  {
  /*add an element to the structure*/
  pairptr newnode;
  newnode=(pairptr)malloc(sizeof(pair));
  newnode->x=x;
  newnode->y=y;
  newnode->z=z;
  newnode->next=top;
  if (!top) {           /*if no element don't try to access NULL->next*/
    top=newnode;
  }
  else  {
    top=newnode;
  }
  return top;           /*return head of list*/
}

/***********************************************/
pairptr insert_sort(pairptr top, int x, int y, int z)  {
  /*add an element to the structure in its correct place*/
  pairptr newnode, traverse, tmp;
  newnode=(pairptr)malloc(sizeof(pair));
  newnode->x=x;
  newnode->y=y;
  newnode->z=z;

  if (!top) {           /*if no element don't try to access NULL->next*/
    newnode->next=NULL;
    return newnode;
  }
  if (z >= top->z)  {
    newnode->next=top;
    return newnode;
  }

  tmp=top;
  traverse=top;
  while (traverse!=NULL && traverse->z > z)  {
    tmp=traverse;
    traverse=traverse->next;
  }
  tmp->next=newnode;
  newnode->next=traverse;

  return top;           /*return head of list*/
}

/***********************************************/
pairptr
rotate(pairptr list, float thetax, float thetay, float thetaz)  {
  float fx, fy, fz, nx, ny, nz;
  int x, y, z;
  pairptr new;
  new=create_empty();
  while (list!=NULL) {
    fx=list->x*1.0;
    fy=list->y*1.0;
    fz=list->z*1.0;
    

    if (thetaz)  {
      nx=fx*cos(thetaz)+fy*sin(thetaz);
      fy=-fx*sin(thetaz)+fy*cos(thetaz);
      fx=nx;
    }
    if (thetax)  {
      ny=fy*cos(thetax)+fz*sin(thetax);
      fz=-fy*sin(thetax)+fz*cos(thetax);
      fy=ny;
    }
    if (thetay)  {
      nx=fx*cos(thetay)-fz*sin(thetay);
      fz=fx*sin(thetay)+fz*cos(thetay);
      fx=nx;
    }
    x=fx;
    y=fy;
    z=fz;
    new=insert_sort(new, x, y, z);  
    list=list->next;
  }

  return new;
}
/***********************************************/
normal(axisptr DOF)  {
  float length;
  length=DOF->x.i*DOF->x.i+DOF->x.j*DOF->x.j+DOF->x.k*DOF->x.k;
  length=sqrt(length);
  DOF->x.i=DOF->x.i/length;
  DOF->x.j=DOF->x.j/length;
  DOF->x.k=DOF->x.k/length;
  
  length=DOF->y.i*DOF->y.i+DOF->y.j*DOF->y.j+DOF->y.k*DOF->y.k;
  length=sqrt(length);
  DOF->y.i=DOF->y.i/length;
  DOF->y.j=DOF->y.j/length;
  DOF->y.k=DOF->y.k/length;
  
  length=DOF->z.i*DOF->z.i+DOF->z.j*DOF->z.j+DOF->z.k*DOF->z.k;
  length=sqrt(length);
  DOF->z.i=DOF->z.i/length;
  DOF->z.j=DOF->z.j/length;
  DOF->z.k=DOF->z.k/length;
}

/***********************************************/
pairptr
pointdof(pairptr list, axisptr DOF)  {
  float fx, fy, fz, nx, ny, nz;
  int x, y, z;
  pairptr new;
  
  new=create_empty();
  
  while (list!=NULL) {
    fx=list->x*1.0;
    fy=list->y*1.0;
    fz=list->z*1.0;
    
    nx=DOF->x.i*fx+DOF->y.i*fy+DOF->z.i*fz;    
    ny=DOF->x.j*fx+DOF->y.j*fy+DOF->z.j*fz;    
    nz=DOF->x.k*fx+DOF->y.k*fy+DOF->z.k*fz;    
    
    x=nx;
    y=ny;
    z=nz;
    new=insert_sort(new, x, y, z);  
    list=list->next;
  }

  return new;
}
/***********************************************/

main () {
  int i,j, check;
  char ch;
  float angx, angy, angz;
  pairptr top, bob, traverse;
  axisptr DOF;
  unsigned char *pict, *pal, *canvas;
  clock_t start_time, end_time;

  //timing stuff
/*  init();

  start_time = clock();
  for (i=0;i<100;i++)  {
    paint(4);
  }
  end_time = clock();
  printf("The time was: %lu\n", (end_time-start_time));
  return 0;*/
//end timing stuff
  
  
  DOF=(axisptr)malloc(sizeof(axis));
  DOF->x.i=0;
  DOF->x.j=.707106;
  DOF->x.k=.707106;
  
  DOF->y.i=0;
  DOF->y.j=.707106;
  DOF->y.k=-.707106;
  
  DOF->z.i=1;
  DOF->z.j=0;
  DOF->z.k=0;
  
  angx=0*3.141592/180;
  angy=0*3.141592/180;
  angz=0*3.141592/180;
  top=create_empty();
  bob=create_empty();
  canvas=malloc(64000);

  top=insert(top,0,0,0);
  top=insert(top,0,0,20);
  top=insert(top,0,0,40);
  top=insert(top,0,0,60);
  top=insert(top,0,0,80);
  
//  top=insert(top,20,0,0);
  top=insert(top,20,0,20);
  top=insert(top,20,0,40);
//  top=insert(top,20,0,60);
  
//  top=insert(top,-20,0,0);
  top=insert(top,-20,0,20);
  top=insert(top,-20,0,40);
//  top=insert(top,-20,0,60);
  
  top=insert(top,40,0,0);
  top=insert(top,40,0,20);
//  top=insert(top,40,0,40);
  
  top=insert(top,-40,0,0);
  top=insert(top,-40,0,20);
//  top=insert(top,-40,0,40);
  
  top=insert(top,0,15,10);
  top=insert(top,0,15,30);
  
  pict=diskread("voxel.vga", 774);
  pal=diskread("voxel.pal", 768);

  init();
  palette(pal);
  paint(0);
  for (i=0;i<200;i++)  {
    pset(i,0,i);
  }
  ch=getch();
  check=0;
  while (ch!='x')  {
    bob=destroy_full_list(bob);
//    bob=rotate(top, angx, angy, angz);
    bob=pointdof(top, DOF);
    traverse=bob;
    clearcan(canvas);
    while (traverse!=NULL) {
      putcan(130+traverse->x,100+traverse->y, pict, canvas);
      traverse=traverse->next;
    }
    paintcan(canvas);
    if (angx>7) angx=angx-2*3.141592;
    if (angy>7) angy=angy-2*3.141592;
    if (angz>7) angz=angz-2*3.141592;
    ch=0;
    check=keypress();
    if (check) ch=getch();
    switch (ch) {
      case '8': angx=angx+.1; 
        DOF->z.i=DOF->z.i+DOF->y.i*.1;
        DOF->z.j=DOF->z.j+DOF->y.j*.1;
        DOF->z.k=DOF->z.k+DOF->y.k*.1;
        DOF->y.i= DOF->z.k*DOF->x.j - DOF->z.j*DOF->x.k;
        DOF->y.j= DOF->z.i*DOF->x.k - DOF->z.k*DOF->x.i;
        DOF->y.k= DOF->z.j*DOF->x.i - DOF->z.i*DOF->x.j;
        normal(DOF);
        break;
      case '2': angx=angx-.1; 
        DOF->z.i=DOF->z.i-DOF->y.i*.1;
        DOF->z.j=DOF->z.j-DOF->y.j*.1;
        DOF->z.k=DOF->z.k-DOF->y.k*.1;
        DOF->y.i=DOF->z.k*DOF->x.j - DOF->z.j*DOF->x.k;
        DOF->y.j=DOF->z.i*DOF->x.k - DOF->z.k*DOF->x.i;
        DOF->y.k=DOF->z.j*DOF->x.i - DOF->z.i*DOF->x.j;
        normal(DOF);
        break;
      case '4': angy=angy+.1; 
        DOF->z.i=DOF->z.i-DOF->x.i*.1;
        DOF->z.j=DOF->z.j-DOF->x.j*.1;
        DOF->z.k=DOF->z.k-DOF->x.k*.1;
        DOF->x.i=-DOF->z.k*DOF->y.j+DOF->z.j*DOF->y.k;
        DOF->x.j=-DOF->z.i*DOF->y.k+DOF->z.k*DOF->y.i;
        DOF->x.k=-DOF->z.j*DOF->y.i+DOF->z.i*DOF->y.j;
        normal(DOF);
        break;
      case '6': angy=angy-.1; 
        DOF->z.i=DOF->z.i+DOF->x.i*.1;
        DOF->z.j=DOF->z.j+DOF->x.j*.1;
        DOF->z.k=DOF->z.k+DOF->x.k*.1;
        DOF->x.i=-DOF->z.k*DOF->y.j+DOF->z.j*DOF->y.k;
        DOF->x.j=-DOF->z.i*DOF->y.k+DOF->z.k*DOF->y.i;
        DOF->x.k=-DOF->z.j*DOF->y.i+DOF->z.i*DOF->y.j;
        normal(DOF);
        break;
      case '3': angz=angz+.1; 
        DOF->y.i=DOF->y.i-DOF->x.i*.1;
        DOF->y.j=DOF->y.j-DOF->x.j*.1;
        DOF->y.k=DOF->y.k-DOF->x.k*.1;
        DOF->x.i=-DOF->z.k*DOF->y.j+DOF->z.j*DOF->y.k;
        DOF->x.j=-DOF->z.i*DOF->y.k+DOF->z.k*DOF->y.i;
        DOF->x.k=-DOF->z.j*DOF->y.i+DOF->z.i*DOF->y.j;
        normal(DOF);
        break;
      case '7': angz=angz-.1;
        DOF->y.i=DOF->y.i+DOF->x.i*.1;
        DOF->y.j=DOF->y.j+DOF->x.j*.1;
        DOF->y.k=DOF->y.k+DOF->x.k*.1;
        DOF->x.i=-DOF->z.k*DOF->y.j+DOF->z.j*DOF->y.k;
        DOF->x.j=-DOF->z.i*DOF->y.k+DOF->z.k*DOF->y.i;
        DOF->x.k=-DOF->z.j*DOF->y.i+DOF->z.i*DOF->y.j;
        normal(DOF);
        break;

      case '0': angx=0;angy=0;angz=0;
        DOF->x.i=-1;
        DOF->x.j=0;
        DOF->x.k=0;
  
        DOF->y.i=0;
        DOF->y.j=1;
        DOF->y.k=0;
  
        DOF->z.i=0;   
        DOF->z.j=0;
        DOF->z.k=1;
        break;
    }
  }
  mode80();
}

