#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include <dos.h>                //for delay
#define NUMBER 7

void init(void);
void paint(int color);
void pset(int x, int y, int color);
void put(int x, int y, unsigned char *picture);
void putran(int x, int y, unsigned char *picture);
void palette(unsigned char *pal);
//extern void __init(void);
//extern void __pset(int, int, int);
//extern void __put(int, int, unsigned char *);
//extern void __palette(unsigned char *);

typedef struct coordinates  {
  int x, y;
  struct coordinates *next;
  } pair, *pairptr;

/*********************************************/
//create and return an empty list
pairptr create_empty(){
pairptr empty;
empty=NULL;
return empty;
}
 
/*********************************************/

/*read in a file to a pointer given size and filename*/
unsigned char *
diskread(char *strn, int size)  {
  FILE *myfile;
  unsigned char *dater;

  if ((dater=malloc(size))==NULL)  {
    printf("DAMNIT");
  }
  if ((myfile = fopen(strn, "rb"))==NULL)  {
    printf("DAMN");
  }
  fread(dater, size, 1, myfile);
  fclose(myfile);
  return dater;
}

/***********************************************/
pairptr destroy_full_list(NODEPTR list)  {
/*frees the memory from a list that is no longer needed*/
pairptr temp;
while (list!=NULL)  {
  temp=list;                    /*don't lose pointer*/
  list=list->next;     /*go to next*/
  free(temp);                   /*erase it*/
  }
return NULL;                    /*return NULL to the pointer cleared*/
}
/***********************************************/
pairptr add_element(NODEPTR top, char element)  {
/*add an element to the structure*/
NODEPTR newnode;
newnode=(NODEPTR)malloc(sizeof(NODE));
newnode->bigger_digits=top;
newnode->smaller_digits=NULL;
newnode->digit=element;
if (!top) {           /*if no element don't try to access NULL->next*/
  top=newnode;
  }
else  {
  top->smaller_digits=newnode;
  top=newnode;
  }
return top;           /*return head of list*/
}

/***********************************************/

void
rotatez(int x, int y, int *nx, int *ny, float theta)  {
  float fx, fy;
  fx=x*1.0;
  fy=y*1.0;


  *nx=fx*cos(theta)-fy*sin(theta);
  *ny=fx*sin(theta)+fy*cos(theta);
  
  return;
}
/***********************************************/

main () {
  int i,j,xa,ya;
  float ang;
  pairptr val, top;
  unsigned char *pict, *pal;

  ang=0*3.141592/180;
  top=create_empty();
  
  val->x=20;
  val->y=0;
  insert(val, top);
  val->x=40;
  val->y=10;
  insert(val, top);
  val->x=50;
  val->y=30;
  insert(val, top);
  val->x=50;
  val->y=50;
  insert(val, top);
  val->x=30;
  val->y=60;
  insert(val, top);
  val->x=10;
  val->y=50;
  insert(val, top);
  val->x=-10;
  val->y=40;
  insert(val, top);

  pict=diskread("voxel.vga", 774);
  pal=diskread("voxel.pal", 768);

  init();
  palette(pal);
  paint(0);
  for (i=0;i<200;i++)  {
    pset(i,0,i);
  }
  for (j=0;j<100;j++)  {
  for (i=0;i<NUMBER;i++)  {
    rotatez(val[i].x, val[i].y, &xa, &ya, ang);
    putran(100+xa,100+ya, pict);
  }
  delay(100);
  paint(0);
  ang=ang+.1;
  } 
}
